JSON for Modern C++ 3.7.3

accept
accept
accept
allocator_type
array
array_t
at
at
at
at
at
at
back
back
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
begin
begin
binary
binary
binary
binary
binary_t
boolean_t
cbegin
cend
clear
const_iterator
const_pointer
const_reference
const_reverse_iterator
contains
contains
count
crbegin
crend
detail::external_constructor
diff
difference_type
dump
emplace
emplace_back
empty
end
end
erase
erase
erase
erase
error_handler_t
exception
find
find
flatten
from_bson
from_bson
from_bson
from_cbor
from_cbor
from_cbor
from_msgpack
from_msgpack
from_msgpack
from_ubjson
from_ubjson
from_ubjson
front
front
get
get
get
get
get
get
get_allocator
get_binary
get_binary
get_ptr
get_ptr
get_ref
get_ref
get_to
get_to
initializer_list_t
input_format_t
insert
insert
insert
insert
insert
insert
insert_iterator
invalid_iterator
is_array
is_binary
is_boolean
is_discarded
is_null
is_number
is_number_float
is_number_integer
is_number_unsigned
is_object
is_primitive
is_string
is_structured
items
items
iterator
iterator_wrapper
iterator_wrapper
json_pointer
json_sax_t
json_serializer
max_size
merge_patch
meta
number_float_t
number_integer_t
number_unsigned_t
object
object_comparator_t
object_t
operator value_t
operator ValueType
operator!=
operator!=
operator!=
operator+=
operator+=
operator+=
operator+=
operator<
operator<
operator<
operator<<
operator<<
operator<=
operator<=
operator<=
operator=
operator==
operator==
operator==
operator>
operator>
operator>
operator>=
operator>=
operator>=
operator>>
operator>>
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
other_error
out_of_range
parse
parse
parse
parse_error
parse_event_t
parser_callback_t
patch
pointer
push_back
push_back
push_back
push_back
rbegin
rbegin
reference
rend
rend
reverse_iterator
sax_parse
sax_parse
sax_parse
size
size_type
string_t
swap
swap
swap
swap
swap
swap
to_bson
to_bson
to_bson
to_cbor
to_cbor
to_cbor
to_msgpack
to_msgpack
to_msgpack
to_ubjson
to_ubjson
to_ubjson
type
type_error
type_name
unflatten
update
update
value
value
value
value
value_t
value_type
~basic_json
| ## ◆ iterator_wrapper() [1/2]
static iteration_proxy<const_iterator> nlohmann::basic_json::iterator_wrapper | ( | const_reference | ref | ) |
| inline static noexcept
  This function allows to access iterator::key() and iterator::value() during range-based for loops. In these loops, a reference to the JSON values is returned, so there is no access to the underlying iterator. For loop without iterator_wrapper: for (auto it = j_object.begin(); it != j_object.end(); ++it) { std::cout << "key: " << it.key() << ", value:" << it.value() << '\n'; } Range-based for loop without iterator proxy: for (auto it : j_object) { // "it" is of type json::reference and has no key() member std::cout << "value: " << it << '\n'; } Range-based for loop with iterator proxy: for (auto it : json::iterator_wrapper(j_object)) { std::cout << "key: " << it.key() << ", value:" << it.value() << '\n'; } Note When iterating over an array, `key()` will return the index of the element as string (see example). Parameters
  [in] | ref | reference to a JSON value
  Returns iteration proxy object wrapping ref with an interface to use in range-based for loops Example The following code shows how the wrapper is used 1 #include <iostream> 2 #include <nlohmann/json.hpp> 3 4 using json = nlohmann::json; 5 6 int main() 7 { 8 // create JSON values 9 json j_object = {{"one", 1}, {"two", 2}}; 10 json j_array = {1, 2, 4, 8, 16}; 11 12 // example for an object 13 for (auto& x : json::iterator_wrapper(j_object)) 14 { 15 std::cout << "key: " << x.key() << ", value: " << x.value() << '\n'; 16 } 17 18 // example for an array 19 for (auto& x : json::iterator_wrapper(j_array)) 20 { 21 std::cout << "key: " << x.key() << ", value: " << x.value() << '\n'; 22 } 23 } Output (play with this example online):
      key: one, value: 1
      key: two, value: 2
      key: 0, value: 1
      key: 1, value: 2
      key: 2, value: 4
      key: 3, value: 8
      key: 4, value: 16
  The example code above can be translated with
      g++ -std=c++11 -Isingle_include doc/examples/iterator_wrapper.cpp -o iterator_wrapper
Exception safety Strong guarantee: if an exception is thrown, there are no changes in the JSON value. Complexity Constant. Note The name of this function is not yet final and may change in the future. Deprecated: This stream operator is deprecated and will be removed in future 4.0.0 of the library. Please use items() instead; that is, replace `json::iterator_wrapper(j)` with `j.items()`. Definition at line 20578 of file json.hpp.

nlohmann::basic_json::iterator_wrapper
static iteration_proxy< iterator > iterator_wrapper(reference ref) noexcept
wrapper to access iterator member functions in range-based for
Definition: json.hpp:20569
nlohmann::json
basic_json<> json
default JSON class
Definition: json.hpp:2774